﻿/*
Copyright (c) 2005-2008, CellAO Team

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the CellAO Team nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using ISComm;
using ISComm.EventArgs;

namespace ChatEngine
{
    public class ISCClient : ClientBaseClass
    {
        /// <summary>
        /// Handler
        /// </summary>
        /// <param name="s"></param>
        /// <param name="a"></param>
        private void ISCClient_OnMessage(object s, OnMessageArgs a)
        {
            System.Console.WriteLine("[ISComm] Packet '" + a.ID + "' catched.");
            switch (a.ID)
            {
                //INSERT PROTOCOL PACKET HANDLING HERE!

                case 0x0F:
                    //this is the vicinity thing
                    MemoryStream stream = new MemoryStream(a.Data);
                    BinaryReader reader = new BinaryReader(stream);

                    short ReceiversAmount = reader.ReadInt16();
                    int[] Receivers = new int[ReceiversAmount];

                    for (int i = 0; i < ReceiversAmount; i++)
                    {
                        Receivers[i] = reader.ReadInt32();
                    }

                    //short MsgLen = reader.ReadInt16();
                    string Message = reader.ReadString();
                    stream.Close();
                    reader.Close();

                    System.Console.WriteLine("Got vicinity from ZoneEngine: " + Message);
                    Packets.MsgVicinity pkt = new ChatEngine.Packets.MsgVicinity();
                    byte[] Packet = pkt.Create((uint)(Receivers[0]), Message, null);

                    foreach (int sendto in Receivers)
                    {
                        foreach (Client cli in server.Clients)
                        {
                            if (cli.Character.characterId == sendto)
                            {
                                cli.Send(Packet);
                            }
                        }
                    }

                    break;
            }
        }

        public ISCClient(string IP, int Port, Server srv)
            : base(IP, Port)
        {
            OnMessage += new OnMessageHandler(ISCClient_OnMessage);

            server = srv;
        }

        internal Server server;
    }
}
