﻿/*
Copyright (c) 2005-2008, CellAO Team

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the CellAO Team nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using System.Collections.Generic;
using System.Text;
using Cell.Core;

namespace ZoneEngine.Misc
{
    /// <summary>
    /// 
    /// </summary>
    class Announce
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="client"></param>
        /// <param name="data"></param>
        public static void Playfield(Client client, byte[] data)
        {
            foreach (Client m_client in client.Server.Clients)
            {
                if (m_client.Character.pf == client.Character.pf)
                {
                    byte[] m_id;
                    m_id = BitConverter.GetBytes(m_client.Character.characterId);
                    Array.Reverse(m_id);
                    data[12] = m_id[0]; data[13] = m_id[1];
                    data[14] = m_id[2]; data[15] = m_id[3];
                    m_client.CmpStream.Write(data, 0, data.Length);
                    m_client.CmpStream.Flush();
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="client"></param>
        /// <param name="data"></param>
        public static void PlayfieldOthers(Client client, byte[] data)
        {
            foreach (Client m_client in client.Server.Clients)
            {
                if ((m_client.Character.pf == client.Character.pf) && (m_client.Character.characterId != client.Character.characterId))
                {
                    byte[] m_id;
                    m_id = BitConverter.GetBytes(m_client.Character.characterId);
                    Array.Reverse(m_id);
                    data[12] = m_id[0]; data[13] = m_id[1];
                    data[14] = m_id[2]; data[15] = m_id[3];
                    m_client.CmpStream.Write(data, 0, data.Length);
                    m_client.CmpStream.Flush();
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="client"></param>
        /// <param name="data"></param>
        public static void Global(Client client, byte[] data)
        {
            byte[] m_id;
            foreach (Client m_client in client.Server.Clients)
            {
                m_id = BitConverter.GetBytes(m_client.Character.characterId);
                Array.Reverse(m_id);
                data[12] = m_id[0]; data[13] = m_id[1];
                data[14] = m_id[2]; data[15] = m_id[3];
                m_client.CmpStream.Write(data, 0, data.Length);
                m_client.CmpStream.Flush();
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="client"></param>
        /// <param name="data"></param>
        public static void GlobalOthers(Client client, byte[] data)
        {
            byte[] m_id;
            foreach (Client m_client in client.Server.Clients)
            {
                if (m_client.Character.characterId != client.Character.characterId)
                {
                    m_id = BitConverter.GetBytes(m_client.Character.characterId);
                    Array.Reverse(m_id);
                    data[12] = m_id[0]; data[13] = m_id[1];
                    data[14] = m_id[2]; data[15] = m_id[3];
                    m_client.CmpStream.Write(data, 0, data.Length);
                    m_client.CmpStream.Flush();
                }
            }
        }

        /* Moved this here so I can delete ChatText.cs */

        /// <summary>
        /// Broadcasts chat message to ALL users on the server
        /// </summary>
        /// <param name="b">Base Client to extract the ServerBase from. Like, who designed this :P</param>
        /// <param name="msg">...</param>
        public static void Broadcast(Client b, string msg)
        {
            foreach (Client c in b.Server.Clients)
            {
                c.SendChatText("System Message: " + msg);
            }
        }
    }
}
