﻿/*
Copyright (c) 2005-2008, CellAO Team

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the CellAO Team nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using System.Collections.Generic;
using System.Text;
using Cell.Core;

namespace ZoneEngine.Misc
{
    /// <summary>
    /// 
    /// </summary>
    public static class FindClient
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="server"></param>
        /// <param name="ID"></param>
        /// <returns></returns>
        public static Client FindClientByID(Server server, int ID)
        {
            foreach (Client _client in server.Clients)
            {
                if (_client.Character.characterId == ID)
                {
                    return _client;

                }
            }
            return null;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="server"></param>
        /// <param name="ID"></param>
        /// <param name="client"></param>
        /// <returns></returns>
        public static bool FindClientByID(Server server, int ID, out Client client)
        {
            foreach (Client _client in server.Clients)
            {
                if (_client.Character.characterId == ID)
                {
                    client = _client;
                    return true;
                }
            }
            client = null;
            return false;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="server"></param>
        /// <param name="name"></param>
        /// <returns></returns>
        public static Client FindClientByName(Server server, string name)
        {
            foreach (Client _client in server.Clients)
            {
                if (_client.Character.characterName == name)
                {
                    return _client;
                }
            }
            return null;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="server"></param>
        /// <param name="name"></param>
        /// <param name="client"></param>
        /// <returns></returns>
        public static bool FindClientByName(Server server, string name, out Client client)
        {
            foreach (Client _client in server.Clients)
            {
                if (_client.Character.characterName == name)
                {
                    client = _client;
                    return true;
                }
            }
            client = null;
            return false;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="server"></param>
        /// <param name="PF"></param>
        /// <returns></returns>
        public static List<Client> FindClientsByPF(Server server, int PF)
        {
            List<Client> _clients = new List<Client>();
            foreach (Client _client in server.Clients)
            {
                if (_client.Character.pf == PF)
                {
                    _clients.Add(_client);
                }
            }
            return _clients;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="server"></param>
        /// <param name="PF"></param>
        /// <param name="clients"></param>
        /// <returns></returns>
        public static bool FindClientsByPF(Server server, int PF, out List<Client> clients)
        {
            List<Client> _clients = new List<Client>();
            foreach (Client _client in server.Clients)
            {
                if (_client.Character.pf == PF)
                {
                    _clients.Add(_client);
                }
            }
            clients = _clients;
            if (_clients.Count >= 1)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
