﻿/*
Copyright (c) 2005-2008, CellAO Team

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the CellAO Team nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using System.Collections.Generic;
using System.Text;


//This File contains all the default Gas_Levels for each Zone District.. Hope it can be useful
//Probably should have the DB team check each Live Zone listed here that they can reach for the accual Gas Level..

namespace ZoneEngine.Misc
{
    /// <summary>
    /// 
    /// </summary>
    public class ZoneInfo
    {
        /// <summary>
        /// 
        /// </summary>
        private class ZoneInformation
        {
            /// <summary>
            /// 
            /// </summary>
            public string ZoneName;
            /// <summary>
            /// 
            /// </summary>
            public int Gas_Level;
        }

        /// <summary>
        /// 
        /// </summary>
        private Dictionary<int, ZoneInformation> Zones;

        /// <summary>
        /// 
        /// </summary>
        public ZoneInfo()
        {
            Zones = new Dictionary<int, ZoneInformation>();
            Zones.Add(101, new ZoneInformation { ZoneName = "DoorDistrict", Gas_Level = 75 });
            Zones.Add(102, new ZoneInformation { ZoneName = "MonsterDistrict", Gas_Level = 75 });
            Zones.Add(103, new ZoneInformation { ZoneName = "Shopanddrop", Gas_Level = 100 });
            Zones.Add(105, new ZoneInformation { ZoneName = "District", Gas_Level = 100 });
            Zones.Add(107, new ZoneInformation { ZoneName = "District", Gas_Level = 100 });
            Zones.Add(109, new ZoneInformation { ZoneName = "District", Gas_Level = 100 });
            Zones.Add(110, new ZoneInformation { ZoneName = "District", Gas_Level = 100 });
            Zones.Add(111, new ZoneInformation { ZoneName = "District", Gas_Level = 100 });
            Zones.Add(120, new ZoneInformation { ZoneName = "NOFIGHT", Gas_Level = 100 });
            Zones.Add(120, new ZoneInformation { ZoneName = "FIGHT", Gas_Level = 50 });
            Zones.Add(124, new ZoneInformation { ZoneName = "Tir Assembly Hall", Gas_Level = 100 });
            Zones.Add(125, new ZoneInformation { ZoneName = "Mantis Hive District", Gas_Level = 75 });
            Zones.Add(125, new ZoneInformation { ZoneName = "Smugglers Den District", Gas_Level = 75 });
            Zones.Add(125, new ZoneInformation { ZoneName = "Mantis Den District", Gas_Level = 75 });
            Zones.Add(127, new ZoneInformation { ZoneName = "Abandoned Hall District", Gas_Level = 75 });
            Zones.Add(127, new ZoneInformation { ZoneName = "Condemned Subway", Gas_Level = 75 });
            Zones.Add(127, new ZoneInformation { ZoneName = "Fractured Sewers", Gas_Level = 75 });
            Zones.Add(127, new ZoneInformation { ZoneName = "Sewer Nucleus", Gas_Level = 75 });
            Zones.Add(128, new ZoneInformation { ZoneName = "District", Gas_Level = 100 });
            Zones.Add(152, new ZoneInformation { ZoneName = "Grid", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_hallway_w_cells", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_wc", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_kitchen", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_rest_rooms", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_locker", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_computer_room", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_communications_room", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_cells", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_elevator", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_stair", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_eating_facilities", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_meeting_room", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_shelf_room", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_large_empty_room", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_hq_room", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_computer_mainframe", Gas_Level = 75 });
            Zones.Add(320, new ZoneInformation { ZoneName = "militaryot_energy_room", Gas_Level = 75 });

        }
    }
}
