﻿/*
Copyright (c) 2005-2008, CellAO Team

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the CellAO Team nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using Cell.Core;
using AO.Core;

namespace ZoneEngine.PacketHandlers
{
    /// <summary>
    /// 
    /// </summary>
    static class CharacterAction
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="packet"></param>
        /// <param name="client"></param>
        public static void Read(byte[] packet, Client client)
        {
            PacketReader m_reader = new PacketReader(packet);
            Header m_header =   m_reader.PopHeader();
            byte unknown =      m_reader.PopByte();
            int actionNum =     m_reader.PopInt();
            int unknown1 =      m_reader.PopInt();
            Identity m_ident =  m_reader.PopIdentity();
            int unknown2 =      m_reader.PopInt();
            int unknown3 =      m_reader.PopInt();
            short unknown4 =    m_reader.PopShort();
            m_reader.Finish();

            /* this is here to prevent server crash that is caused by
             * search action if server doesn't reply if something is
             * found or not */

            if (actionNum == 0x42) // If action == search
            {
                /* Msg 110:136744723 = "No hidden objects found." */
                client.SendFeedback(110, 136744723);
            }
            else
            {
                byte[] action = new byte[0x37];
                Array.Copy(packet, action, 0x37);
                action[8] = 0x00; action[9] = 0x00;
                action[10] = 0x0C; action[11] = 0x0E;
                Misc.Announce.Playfield(client, action);
            }
        }
    }
}